#######################################################################
##### Part of the VortexGE Configuration Script                   #####
##### Copyright (C) 2004-2006 Aloysius Indrayanto                 #####
##### GNU Lesser General Public License                           #####
##### ----------------------------------------------------------- #####
##### EDITING THIS FILE ERRONEOUSLY MAY CAUSE THIS SCRIPT TO FAIL #####
##### ----------------------------------------------------------- #####
##### This program is distributed WITHOUT ANY WARRANTY.           #####
##### See the GNU Lesser General Public License for more details. #####
#######################################################################

#######################################################################
##### Functions for Checking All the Needed Prequisites
#######################################################################

##### Check prerequisite
CheckPrerequisite()
{
  ##### GNU g++
  echo -n $_COLOR_PURPLE"Checking for GNU g++ .... "$_COLOR_NORMAL
  FindTheBestGpp GNUGccCmd GNUGppCmd GNUGppVer
  if (( GNUGppVer > 0 )); then
    local __mj__
    local __mn__
    local __pl__
    let '__mj__=(GNUGppVer / 10000)'
    let '__mn__=(GNUGppVer - __mj__*10000)/100'
    let '__pl__=(GNUGppVer - __mj__*10000 - __mn__*100)'
    echo "$_COLOR_BLUE$GNUGppCmd$_COLOR_GREEN (GCC $__mj__.$__mn__.$__pl__)$_COLOR_NORMAL"
    if (( GNUGppVer < 30400 )); then
      echo $_COLOR_RED"Warning: the GCC found in the system is lower than version 3.4.0,"$COLOR_NORMAL
      echo $_COLOR_RED"         manual interference will be needed when building VortexGE"$COLOR_NORMAL
    fi
  else
    echo $_COLOR_RED"NOT FOUND"
    echo $_COLOR_NORMAL
    exit 1
  fi

  ##### Zlib
  echo -n $_COLOR_PURPLE"Checking for zlib ....... "$_COLOR_NORMAL
  FindZlib ZlbIncLoc ZlbLibLoc
  if [[ $ZlbIncLoc == '' ]] || [[ $ZlbLibLoc == '' ]]; then
    echo $_COLOR_RED"NOT FOUND"
    echo $_COLOR_NORMAL
    exit 1
  else
    echo "$_COLOR_BLUE$ZlbIncLoc $ZlbLibLoc$_COLOR_NORMAL"
    AddCustomIncludeLocation $ZlbIncLoc
    AddCustomLibraryLocation $ZlbLibLoc
  fi

  ##### X11
  echo -n $_COLOR_PURPLE"Checking for X11 ........ "$_COLOR_NORMAL
  FindX11 X11IncLoc X11LibLoc
  if [[ $X11IncLoc == '#ERROR' ]] || [[ $X11LibLoc == '#ERROR' ]]; then
    echo $_COLOR_NORMAL
    exit 1
  elif [[ $X11IncLoc == '' ]] || [[ $X11LibLoc == '' ]]; then
    echo $_COLOR_RED"NOT FOUND"
    echo $_COLOR_NORMAL
    exit 1
  else
    echo "$_COLOR_BLUE$X11IncLoc $X11LibLoc$_COLOR_NORMAL"
    AddCustomIncludeLocation $X11IncLoc
    AddCustomLibraryLocation $X11LibLoc
  fi
  echo -n $_COLOR_PURPLE"  Has libXxf86vm.so ..... "
  PrintYesNo $_COLOR_BLUE $Xxf86vmso

  ##### OSS
  echo -n $_COLOR_PURPLE"Checking for OSS ........ "$_COLOR_NORMAL
  FindOss OssIncLoc
  if [[ $OssIncLoc == '' ]]; then
    echo $_COLOR_RED"NOT FOUND"$_COLOR_NORMAL
  else
    echo "$_COLOR_BLUE$OssIncLoc$_COLOR_NORMAL"
  fi

  ##### ALSA
  echo -n $_COLOR_PURPLE"Checking for ALSA ....... "$_COLOR_NORMAL
  FindAlsa AlsIncLoc AlsLibLoc
  if [[ $AlsIncLoc == '' ]] || [[ $AlsLibLoc == '' ]]; then
    echo $_COLOR_RED"NOT FOUND"$_COLOR_NORMAL
  else
    echo "$_COLOR_BLUE$AlsIncLoc $AlsLibLoc$_COLOR_NORMAL"
  fi

  ##### libpng
  if [[ $UseLibPng != 'D' ]]; then
    echo -n $_COLOR_PURPLE"Checking for libpng ..... "$_COLOR_NORMAL
    FindLibpng PngIncLoc PngLibLoc
    if [[ $PngIncLoc == '' ]] || [[ $PngLibLoc == '' ]]; then
      UseLibPng='N'
      echo $_COLOR_RED"NOT FOUND"$_COLOR_NORMAL
    else
      UseLibPng='Y'
      echo "$_COLOR_BLUE$PngIncLoc $PngLibLoc$_COLOR_NORMAL"
    fi
  fi

  ##### libjpeg
  if [[ $UseLibJpg != 'D' ]]; then
    echo -n $_COLOR_PURPLE"Checking for libjpeg .... "$_COLOR_NORMAL
    FindLibjpeg JpgIncLoc JpgLibLoc
    if [[ $JpgIncLoc == '' ]] || [[ $JpgLibLoc == '' ]]; then
      UseLibJpg='N'
      echo $_COLOR_RED"NOT FOUND"$_COLOR_NORMAL
    else
      UseLibJpg='Y'
      echo "$_COLOR_BLUE$JpgIncLoc $JpgLibLoc$_COLOR_NORMAL"
    fi
  fi

  ##### libtiff
  if [[ $UseLibTif != 'D' ]]; then
    echo -n $_COLOR_PURPLE"Checking for libtiff .... "$_COLOR_NORMAL
    FindLibtiff TifIncLoc TifLibLoc
    if [[ $TifIncLoc == '' ]] || [[ $TifLibLoc == '' ]]; then
      UseLibTif='N'
      echo $_COLOR_RED"NOT FOUND"$_COLOR_NORMAL
    else
      UseLibTif='Y'
      echo "$_COLOR_BLUE$TifIncLoc $TifLibLoc$_COLOR_NORMAL"
    fi
  fi

  ##### libungif
  if [[ $UseLibGif != 'D' ]]; then
    echo -n $_COLOR_PURPLE"Checking for libungif ... "$_COLOR_NORMAL
    FindLibungif GifIncLoc GifLibLoc
    if [[ $GifIncLoc == '' ]] || [[ $GifLibLoc == '' ]]; then
      UseLibGif='N'
      echo $_COLOR_RED"NOT FOUND"$_COLOR_NORMAL
    else
      UseLibGif='Y'
      echo "$_COLOR_BLUE$GifIncLoc $GifLibLoc$_COLOR_NORMAL"
    fi
  fi

  ##### Doxygen
  echo -n $_COLOR_PURPLE"Checking for doxygen .... "$_COLOR_NORMAL
  CheckDoxygen BuildAPID
  echo ''
}
