#######################################################################
##### Part of the VortexGE Configuration Script                   #####
##### Copyright (C) 2004-2006 Aloysius Indrayanto                 #####
##### GNU Lesser General Public License                           #####
##### ----------------------------------------------------------- #####
##### EDITING THIS FILE ERRONEOUSLY MAY CAUSE THIS SCRIPT TO FAIL #####
##### ----------------------------------------------------------- #####
##### This program is distributed WITHOUT ANY WARRANTY.           #####
##### See the GNU Lesser General Public License for more details. #####
#######################################################################

#######################################################################
##### Functions for Processing User Options (for Non Interactive Mode)
#######################################################################

##### Determine the sub options for _IMDefaultCstm
GetSubOption_IMDefaultCstm()
{
  if [[ ${2:0:8} == "--prefix" ]]; then
    if [[ $2 == "--prefix" ]] || [[ $2 == "--prefix=" ]]; then
      export $1=$4
      export $6=$2
    else
      if [[ $VGInsDSel != '' ]]; then
        export $1=$5
        export $7=${2:0:9}
      else
        VGInsDSel=${2:9}
      fi
    fi
  elif [[ $2 == "--disable-xf86vm" ]]; then
    if [[ $UseXF86VM != '' ]]; then
      export $1=$5
      export $7=$2
    else
      UseXF86VM='D'
    fi
  elif [[ $2 == "--disable-xshm" ]]; then
    if [[ $UseXShmEx != '' ]]; then
      export $1=$5
      export $7=$2
    else
      UseXShmEx='D'
    fi
  elif [[ $2 == "--disable-xmu" ]]; then
    if [[ $UseXMuExt != '' ]]; then
      export $1=$5
      export $7=$2
    else
      UseXMuExt='D'
    fi
  elif [[ $2 == "--disable-png" ]]; then
    if [[ $UseLibPng != '' ]]; then
      export $1=$5
      export $7=$2
    else
      UseLibPng='D'
    fi
  elif [[ $2 == "--disable-jpeg" ]]; then
    if [[ $UseLibJpg != '' ]]; then
      export $1=$5
      export $7=$2
    else
      UseLibJpg='D'
    fi
  elif [[ $2 == "--disable-tiff" ]]; then
    if [[ $UseLibTif != '' ]]; then
      export $1=$5
      export $7=$2
    else
      UseLibTif='D'
    fi
  elif [[ $2 == "--disable-gif" ]]; then
    if [[ $UseLibGif != '' ]]; then
      export $1=$5
      export $7=$2
    else
      UseLibGif='D'
    fi
  elif [[ $2 == "--disable-asm" ]]; then
    if [[ $InlineAsm != '' ]]; then
      export $1=$5
      export $7=$2
    else
      InlineAsm='D'
    fi
  elif [[ $2 == "--enable-debug" ]]; then
    if [[ $UseDebugI != '' ]]; then
      export $1=$5
      export $7=$2
    else
      UseDebugI='E'
    fi
  elif [[ $2 == "--enable-static" ]]; then
    if [[ $BuildALib != '' ]]; then
      export $1=$5
      export $7=$2
    else
      BuildALib='E'
    fi
  else
    export $1=$3
    export $6=$2
  fi
}

##### Get the parameters given by user
GetParams()
{
  local __s_ok__=0
  local __s_too_many__=1
  local __s_invalid_1__=2   # Invalid option
  local __s_invalid_1b__=3  # Invalid combination of option
  local __s_invalid_2__=4   # Invalid sub-option
  local __s_incomplete__=5
  local __s_duplicate__=6

  local __status__=__s_ok__
  local __pcount__=1
  local __inv_name__
  local __dup_name__

  ##### No parameter given
  if (( $# == 0 )); then
    CnfgRMode=$_IMInteractive
  ##### Parameter given: 1
  elif (( $# == 1 )); then
    if [[ $1 == "--help" ]]; then
      ShowUsage
      ExitScript 1
    elif [[ $1 == "--default" ]]; then
      CnfgRMode=$_IMDefaultOpts
    elif [[ $1 == "--classic-tui" ]]; then
      export VGE_FORCE_CLASSIC_TUI='Y'
      CnfgRMode=$_IMInteractive
    elif [[ $1 == "--fload" ]]; then
      CnfgRMode=$_IMLoadFmOFile
    elif [[ $1 == "--fsave" ]]; then
      CnfgRMode=$_IMSaveToOFile
    elif [[ $1 == "--clean" ]]; then
      Clean
    else
      __status__=__s_invalid_1__
      __inv_name__=$1
    fi
  ##### Parameter given: 2 to 12
  elif (( $# >= 2 )) && (( $# <= 12 )); then
    ##### Check for combination of "--classic-tui" and "--fsave"
    if (( $# == 2 )) && [[ $1 == "--classic-tui" ]]; then
      export VGE_FORCE_CLASSIC_TUI='Y'
      CnfgRMode=$_IMSaveToOFile
      if [[ $2 != "--fsave" ]]; then
        __status__=__s_invalid_1b__
      fi
    elif (( $# == 2 )) && [[ $1 == "--fsave" ]]; then
      export VGE_FORCE_CLASSIC_TUI='Y'
      CnfgRMode=$_IMSaveToOFile
      if [[ $2 != "--classic-tui" ]]; then
        __status__=__s_invalid_1b__
      fi
    ##### We has "--default" in the 1st parameter, check the sub-option(s)
    elif [[ $1 == "--default" ]]; then
      local __tp__=$#
      while (( __pcount__ < $__tp__ )); do
        GetSubOption_IMDefaultCstm __status__ $2 __s_invalid_2__ __s_incomplete__ __s_duplicate__ __inv_name__ __dup_name__
        if (( __status__ != __s_ok__ )); then
          break
        fi
        shift 1
        let __pcount__+=1
      done
      CnfgRMode=$_IMDefaultCstm
    else
      __status__=__s_too_many__
    fi
  ##### Too many parameters given
  else
    __status__=__s_too_many__
  fi

  ##### Proceeed based on the status
  if (( __status__ == __s_ok__ )); then
    if [[ $VGInsDSel == '' ]]; then
      VGInsDSel="$VGInsDDef"
    fi
    return
  elif (( __status__ == __s_too_many__ )); then
    echo $_COLOR_RED"ERROR: Too many and/or invalid parameters."$_COLOR_NORMAL
  elif (( __status__ == __s_invalid_1__ )); then
    echo $_COLOR_RED"ERROR: \"$1\" is an invalid [option]."$_COLOR_NORMAL
  elif (( __status__ == __s_invalid_1b__ )); then
    echo $_COLOR_RED"ERROR: \"$*\" is an invalid combination of [option]s."$_COLOR_NORMAL
  elif (( __status__ == __s_invalid_2__  )); then
    echo $_COLOR_RED"ERROR: \"$__inv_name__\" is an invalid [sub-option]."$_COLOR_NORMAL
  elif (( __status__ == __s_incomplete__)); then
    echo $_COLOR_RED"ERROR: \"$__inv_name__\" is an incomplete [sub-option]."$_COLOR_NORMAL
  elif (( __status__ == __s_duplicate__)); then
    echo $_COLOR_RED"ERROR: [sub-option] \"$__dup_name__\" is duplicated."$_COLOR_NORMAL
  fi
  echo ''
  ShowUsage
  ExitScript 1
}
