#######################################################################
##### Part of the VortexGE Configuration Script                   #####
##### Copyright (C) 2004-2006 Aloysius Indrayanto                 #####
##### GNU Lesser General Public License                           #####
##### ----------------------------------------------------------- #####
##### EDITING THIS FILE ERRONEOUSLY MAY CAUSE THIS SCRIPT TO FAIL #####
##### ----------------------------------------------------------- #####
##### This program is distributed WITHOUT ANY WARRANTY.           #####
##### See the GNU Lesser General Public License for more details. #####
#######################################################################

#######################################################################
##### Functions for User Interaction Using Simple TUI
#######################################################################

##### Print the user's answer (yes/no)
PrintYesNo()
{
  if [[ $2 == 'Y' ]]; then
    echo $1'Yes'$_COLOR_NORMAL
  else
    echo $1'No'$_COLOR_NORMAL
  fi
}

##### Print the user's choice
PrintChoice()
{
  echo $1$2$_COLOR_NORMAL
}

##### Ask the user for yes/no
AskYesNo()
{
  local __Chs__
  while :; do
    read -s -n1 __Chs__
    if [[ $__Chs__ == '' ]]; then
      __Chs__=$2; break
    elif [[ $__Chs__ == [YyNn] ]]; then
      break;
    else
      echo -n -e "\a"
    fi
  done
  __Chs__=${__Chs__/y/Y}; __Chs__=${__Chs__/n/N}
  export $1=$__Chs__
}

##### Ask the user for choices
AskChoice()
{
  local __Chs__
  while :; do
    read -s -n1 __Chs__
    if [[ $__Chs__ == '' ]]; then
      __Chs__=$3; break
    elif [[ $__Chs__ == [$2] ]]; then
      break
    else
      echo -n -e "\a"
    fi
  done
  export $1=$__Chs__
}

##### Ask the user for directory name
AskDir()
{
  local __Chs__
  local __Dir__
  while :; do
    read -s -n1 __Chs__
    if [[ $__Chs__ == '' ]]; then
      if [[ $__Dir__ == '' ]]; then
        __Dir__=$3;
        echo -n $1$__Dir__$_COLOR_NORMAL
      fi
      break;
    else
      if [[ $__Chs__ == ['A'-'Z','a'-'z','0'-'9','_','-','+','=','/','.'] ]]; then
        echo -n $1$__Chs__$_COLOR_NORMAL
        __Dir__=$__Dir__$__Chs__
      else
        echo -n -e "\a"
      fi
    fi
  done
  export $2=$__Dir__
  echo ''
}

##### Interactively ask the user for some options using simple TUI
DoSimpleTUI()
{
  ##### Ask for the installation directory
  echo -n $_COLOR_GREEN"Installation directory [$VGInsDDef] ? "$_COLOR_NORMAL
  AskDir $_COLOR_RED VGInsDSel $VGInsDDef
  FixDir $VGInsDSel VGInsDSel
  echo ''

  ##### Ask for processor type to be used
  echo $_COLOR_GREEN"Supported CPUs :"$_COLOR_WHITE
  echo "    0. Autodetect             "
  echo "    1. Any i586 Compatible    "
  echo "    2. Any i686 Compatible    "
  echo "    3. Intel's CPUs        ..."
  echo "    4. AMD's CPUs          ..."
  echo "    5. Other Vendors' CPUs ..."
  echo -n $_COLOR_GREEN"Your choice [0] ? "$_COLOR_NORMAL
  AskChoice Processor '012345' '0'
    if [[ $Processor ==  '0' ]]; then Processor=$CPU_Autodetect
  elif [[ $Processor ==  '1' ]]; then Processor=$CPU_Anyi586Compatible
  elif [[ $Processor ==  '2' ]]; then Processor=$CPU_Anyi686Compatible
  elif [[ $Processor ==  '3' ]]; then
    echo $_COLOR_BLUE"Intel's CPUs :"$_COLOR_WHITE
    echo "    0. Pentium            "
    echo "    1. Pentium MMX        "
    echo "    2. Pentium Pro        "
    echo "    3. Pentium II         "
    echo "    4. Pentium II Celeron "
    echo "    5. Pentium II Xeon    "
    echo "    6. Pentium III        "
    echo "    7. Pentium III Celeron"
    echo "    8. Pentium III Xeon   "
    echo "    9. Pentium M          "
    echo "    A. Pentium M Celeron  "
    echo "    B. Pentium 4          "
    echo "    C. Pentium 4 Celeron  "
    echo "    D. Pentium 4 Xeon     "
    echo "    E. Pentium 4 Prescott "
    echo "    F. Pentium 4 Celeron D"
    echo "    G. Pentium 4 Nocona   "
    echo "    H. Pentium D          "
    echo "    I. Core Solo          "
    echo "    J. Core Duo           "
    echo "    K. Core 2 Duo         "
    echo -n $_COLOR_GREEN"Your choice [B] ? "$_COLOR_NORMAL
    AskChoice Processor '0123456789AaBbCcDdEeFfGgHhIiJjKk' 'B'
      if [[ $Processor ==  '0' ]]; then Processor=$CPU_IntelPentium
    elif [[ $Processor ==  '1' ]]; then Processor=$CPU_IntelPentiumMMX
    elif [[ $Processor ==  '2' ]]; then Processor=$CPU_IntelPentiumPro
    elif [[ $Processor ==  '3' ]]; then Processor=$CPU_IntelPentiumII
    elif [[ $Processor ==  '4' ]]; then Processor=$CPU_IntelCeleron
    elif [[ $Processor ==  '5' ]]; then Processor=$CPU_IntelP2Xeon
    elif [[ $Processor ==  '6' ]]; then Processor=$CPU_IntelPentiumIII;  UseSSEMOp=1
    elif [[ $Processor ==  '7' ]]; then Processor=$CPU_IntelCeleron2;    UseSSEMOp=1
    elif [[ $Processor ==  '8' ]]; then Processor=$CPU_IntelP3Xeon;      UseSSEMOp=1
    elif [[ $Processor ==  '9' ]]; then Processor=$CPU_IntelPentiumM;    UseSSEMOp=1
    elif [[ $Processor == [Aa] ]]; then Processor=$CPU_IntelCeleronM;    UseSSEMOp=1
    elif [[ $Processor == [Bb] ]]; then Processor=$CPU_IntelPentium4;    UseSSEMOp=1
    elif [[ $Processor == [Cc] ]]; then Processor=$CPU_IntelCeleron3;    UseSSEMOp=1
    elif [[ $Processor == [Dd] ]]; then Processor=$CPU_IntelP4Xeon;      UseSSEMOp=1
    elif [[ $Processor == [Ee] ]]; then Processor=$CPU_IntelPrescott;    UseSSEMOp=1
    elif [[ $Processor == [Ff] ]]; then Processor=$CPU_IntelCeleronD;    UseSSEMOp=1
    elif [[ $Processor == [Gg] ]]; then Processor=$CPU_IntelNocona;      UseSSEMOp=1
    elif [[ $Processor == [Hh] ]]; then Processor=$CPU_IntelPentiumD;    UseSSEMOp=1
    elif [[ $Processor == [Ii] ]]; then Processor=$CPU_IntelCoreSolo;    UseSSEMOp=1
    elif [[ $Processor == [Jj] ]]; then Processor=$CPU_IntelCoreDuo;     UseSSEMOp=1
    elif [[ $Processor == [Kk] ]]; then Processor=$CPU_IntelCore2Duo;    UseSSEMOp=1
    else                                Processor=$CPU_Anyi586Compatible
    fi
  elif [[ $Processor ==  '4' ]]; then
    echo $_COLOR_BLUE"AMD's CPUs :"$_COLOR_WHITE
    echo "    0. K6                 "
    echo "    1. K6 II              "
    echo "    2. K6 III             "
    echo "    3. Athlon             "
    echo "    4. Athlon Thunderbird "
    echo "    5. Duron              "
    echo "    6. Athlon 4           "
    echo "    7. Athlon XP          "
    echo "    8. Athlon MP          "
    echo "    9. K8                 "
    echo "    A. K8 Opteron         "
    echo "    B. Athlon 64          "
    echo "    C. Athlon 64 Sempron  "
    echo "    D. Athlon 64 Turion   "
    echo "    E. Athlon 64 FX       "
    echo "    F. Athlon 64 X2       "
    echo -n $_COLOR_GREEN"Your choice [B] ? "$_COLOR_NORMAL
    AskChoice Processor '0123456789AaBbCcDdEeFf' 'B'
      if [[ $Processor ==  '0' ]]; then Processor=$CPU_AMDK6
    elif [[ $Processor ==  '1' ]]; then Processor=$CPU_AMDK6II
    elif [[ $Processor ==  '2' ]]; then Processor=$CPU_AMDK6III
    elif [[ $Processor ==  '3' ]]; then Processor=$CPU_AMDAthlon
    elif [[ $Processor ==  '4' ]]; then Processor=$CPU_AMDAthlonTBird
    elif [[ $Processor ==  '5' ]]; then Processor=$CPU_AMDDuron
    elif [[ $Processor ==  '6' ]]; then Processor=$CPU_AMDAthlon4;       UseSSEMOp=1
    elif [[ $Processor ==  '7' ]]; then Processor=$CPU_AMDAthlonXP;      UseSSEMOp=1
    elif [[ $Processor ==  '8' ]]; then Processor=$CPU_AMDAthlonMP;      UseSSEMOp=1
    elif [[ $Processor ==  '9' ]]; then Processor=$CPU_AMDK8;            UseSSEMOp=1
    elif [[ $Processor == [Aa] ]]; then Processor=$CPU_AMDOpteron;       UseSSEMOp=1
    elif [[ $Processor == [Bb] ]]; then Processor=$CPU_AMDAthlon64;      UseSSEMOp=1
    elif [[ $Processor == [Cc] ]]; then Processor=$CPU_AMDSempron;       UseSSEMOp=1
    elif [[ $Processor == [Dd] ]]; then Processor=$CPU_AMDTurion;        UseSSEMOp=1
    elif [[ $Processor == [Ee] ]]; then Processor=$CPU_AMDAthlonFX;      UseSSEMOp=1
    elif [[ $Processor == [Ff] ]]; then Processor=$CPU_AMDAthlonX2;      UseSSEMOp=1
    else                                Processor=$CPU_Anyi586Compatible
    fi
  else
    echo $_COLOR_BLUE"Other Vendors' CPUs :"$_COLOR_WHITE
    echo "    0. IDT Winchip C6"
    echo "    1. IDT Winchip 2 "
    echo "    2. Via C3        "
    echo "    3. Via C3-2      "
    echo -n $_COLOR_GREEN"Your choice [3] ? "$_COLOR_NORMAL
    AskChoice Processor '0123' '3'
      if [[ $Processor ==  '0' ]]; then Processor=$CPU_IDTWinChipC6;
    elif [[ $Processor ==  '1' ]]; then Processor=$CPU_IDTWinChip2;
    elif [[ $Processor ==  '2' ]]; then Processor=$CPU_ViaC3;
    elif [[ $Processor ==  '3' ]]; then Processor=$CPU_ViaC3II;          UseSSEMOp=1
    else                                Processor=$CPU_Anyi586Compatible
    fi  fi
  PrintChoice $_COLOR_RED "$Processor"

  echo $_COLOR_BROWN
  echo "Autodetecting MMX, 3DNow! and SSE will override the default per CPU's settings"
  echo "(not reccommended if for building generic binary distribution package)."$_COLOR_WHITE" "
  echo -n $_COLOR_GREEN"Would you like to autodetect them [Y] ? "$_COLOR_NORMAL
  AskYesNo DetectPEx 'Y'
  PrintYesNo $_COLOR_RED $DetectPEx
  echo ''

  ##### Ask for colored console messages
  echo -n $_COLOR_GREEN"Would you like to use color for VortexGE console messages [Y] ? "$_COLOR_NORMAL
  AskYesNo ColorMsgs 'Y'
  PrintYesNo $_COLOR_RED $ColorMsgs
  echo ''

  ##### Ask for xf86vm extension (if detected)
  if [[ $UseXF86VM == 'Y' ]]; then
    echo -n $_COLOR_GREEN"Would you like to use xf86vm extension [Y] ? "$_COLOR_NORMAL
    AskYesNo UseXF86VM 'Y'
    PrintYesNo $_COLOR_RED $UseXF86VM
    echo ''
  fi

  ##### Ask for xshm extension (if detected)
  if [[ $UseXShmEx == 'Y' ]]; then
    echo -n $_COLOR_GREEN"Would you like to use X shared memory (xshm) extension [Y] ? "$_COLOR_NORMAL
    AskYesNo UseXShmEx 'Y'
    PrintYesNo $_COLOR_RED $UseXShmEx
    echo ''
  fi

  ##### Ask for PNG support (if libpng is detected)
  if [[ $PngIncLoc != '' ]] && [[ $PngLibLoc != '' ]]; then
    echo -n $_COLOR_GREEN"Would you like to enable PNG file loading support [Y] ? "$_COLOR_NORMAL
    AskYesNo UseLibPng 'Y'
    PrintYesNo $_COLOR_RED $UseLibPng
    echo ''
  fi

  ##### Ask for JPEG support (if libjpeg is detected)
  if [[ $JpgIncLoc != '' ]] && [[ $JpgLibLoc != '' ]]; then
    echo -n $_COLOR_GREEN"Would you like to enable JPEG file loading support [Y] ? "$_COLOR_NORMAL
    AskYesNo UseLibJpg 'Y'
    PrintYesNo $_COLOR_RED $UseLibJpg
    echo ''
  fi

  ##### Ask for TIFF support (if libtiff is detected)
  if [[ $TifIncLoc != '' ]] && [[ $TifLibLoc != '' ]]; then
    echo -n $_COLOR_GREEN"Would you like to enable TIFF file loading support [Y] ? "$_COLOR_NORMAL
    AskYesNo UseLibTif 'Y'
    PrintYesNo $_COLOR_RED $UseLibTif
    echo ''
  fi

  ##### Ask for GIF support (if libungif is detected)
  if [[ $GifIncLoc != '' ]] && [[ $GifLibLoc != '' ]]; then
    echo -n $_COLOR_GREEN"Would you like to enable GIF file loading support [Y] ? "$_COLOR_NORMAL
    AskYesNo UseLibGif 'Y'
    PrintYesNo $_COLOR_RED $UseLibGif
    echo ''
  fi

  ##### Ask for inline assembly optimizations
  echo -n $_COLOR_GREEN"Would you like to enable inline assembly optimizations [Y] ? "$_COLOR_NORMAL
  AskYesNo InlineAsm 'Y'
  PrintYesNo $_COLOR_RED $InlineAsm
  echo ''

  ##### Ask for debugging information
  echo -n $_COLOR_GREEN"Would you like to enable debugging information [N] ? "$_COLOR_NORMAL
  AskYesNo UseDebugI 'N'
  PrintYesNo $_COLOR_RED $UseDebugI
  echo ''

  ##### Ask for static library
  echo -n $_COLOR_GREEN"Would you like to build the static library also [N] ? "$_COLOR_NORMAL
  AskYesNo BuildALib 'N'
  PrintYesNo $_COLOR_RED $BuildALib
  echo ''

  ##### Enable these options by default
  AlignedMO='Y'
  QuadWrdMO='Y'

  ##### Ask for optimization level
  if [[ $UseDebugI == 'Y' ]]; then
    echo -n $_COLOR_GREEN"Optimization level (0-3) [0] ? "$_COLOR_NORMAL
    AskChoice OptzLevel '0123' '0'
  else
    echo -n $_COLOR_GREEN"Optimization level (0-3) [3] ? "$_COLOR_NORMAL
    AskChoice OptzLevel '0123' '3'
  fi
  PrintChoice $_COLOR_RED $OptzLevel
  echo ''
}
