// ############################################################################################
//  VLGame-AThread.cc
//  A demo application for VortexGE (implementation of VLGame's audio thread)
//  -------------------------------------------------------------------------------------------
//  Copyright (C) 2004-2006 Aloysius Indrayanto
//  This file is part of VortexGE
//
//  This program is free software; you can redistribute it and/or modify it under the terms of
//  the GNU Lesser General Public License as published by the Free Software Foundation; either
//  version 2.1 of the License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License along with this
//  library; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
//  Boston, MA 02111-1307 USA.
// ############################################################################################

// VLGame's headers
#include "VLGame-AppClass.h"

//
// VLGAudioThread implementation
//
VLGAudioThread::VLGAudioThread(VLGApplication &myApp)
: _myApp(myApp)
{
}

uint64_t VLGAudioThread::ThreadCallback(TThreadData &threadData)
{
  //CThread &inst = VTM_INSTANCE(threadData);
  //void    *usrd = VTM_USER_DATA<void*>(threadData);

  while(VTM_NOT_EXIT(threadData)) {
    if(VTM_SUSPENDED(threadData, 100000)) 
      continue;
    else {
      _myApp.iAudioEnv().UpdateBuffer();
      usleep(1000);
    }
  }
  return(0);
}
