// ############################################################################################
//  AALSASoundBuffer.cc
//  Implementation of CAlsaSoundBuffer class using ALSA audio system
//  -------------------------------------------------------------------------------------------
//  Copyright (C) 2004-2006 Aloysius Indrayanto
//  This file is part of VortexGE
//
//  This library is free software; you can redistribute it and/or modify it under the terms of
//  the GNU Lesser General Public License as published by the Free Software Foundation; either
//  version 2.1 of the License, or (at your option) any later version.
//
//  This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License along with this
//  library; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
//  Boston, MA 02111-1307 USA.
// ############################################################################################
#include "../../VConfig.h"
#ifdef __USE_ALSA_AUDIO__

// VortexGE headers
#include "AALSASoundBuffer.h"


namespace vge {

//
// ALSA sound buffer implementation
//
CAlsaSoundBuffer::~CAlsaSoundBuffer() throw()
{
}

void CAlsaSoundBuffer::Play(bool bLooping)
{
  _if_unlikely((CAlsaAudioEnv::_instance->_tD.deviceHandle <= 0) || (_tD.pucLeft == NULL)) return;
  CSoundBufferCImp::Play(bLooping);
}

bool CAlsaSoundBuffer::IsPlaying() const
{
  _if_unlikely((CAlsaAudioEnv::_instance->_tD.deviceHandle <= 0) || (_tD.pucLeft == NULL)) return(false);
  return(CSoundBufferCImp::IsPlaying());
}

void CAlsaSoundBuffer::Stop()
{
  _if_unlikely((CAlsaAudioEnv::_instance->_tD.deviceHandle <= 0) || (_tD.pucLeft == NULL)) return;
  CSoundBufferCImp::Stop();
}

} // namespace vge
#endif
